简体   繁体   English

Solidworks&Excel C#引用设计表

[英]Solidworks & Excel C# Referencing the Design Table

I can't get my design table to modify when opened the line I am having the trouble is var sheet = (Excel._Worksheet)swDoc.GetDesignTable; 打开遇到麻烦的行时,我无法修改设计表,原因是var sheet =(Excel._Worksheet)swDoc.GetDesignTable; . Essentially what I want it to do is open the window and reference the active sheet which is the "Design Table". 本质上,我要它执行的操作是打开窗口,并引用活动表“设计表”。 The API does include "DesignTable" as type. 该API确实包括“ DesignTable”作为类型。 I have been stuck for a while. 我被困了一段时间。 Any help is appreciated. 任何帮助表示赞赏。

        //Open Solidworks Design Table
        SldWorks swApp;
        swApp = null;
        swApp = (SldWorks)Activator.CreateInstance(Type.GetTypeFromProgID("SldWorks.Application"));

        ModelDoc2 swDoc = null;
        bool boolstatus = false;
        swDoc = ((ModelDoc2)(swApp.ActiveDoc));
        boolstatus = swDoc.Extension.SelectByID2("Design Table", "DESIGNTABLE", 0, 0, 0, false, 0, null, 0);
        swDoc.InsertFamilyTableEdit();
        var sheet = (Excel._Worksheet)swDoc.GetDesignTable;

        //Generate Linear Guide Support in Solidworks
        if (comboBox1.Text == "0")//No External Rails
        {
           sheet.Cells[6, 4] = "0"; //Cell Location [y-axis, x-axis]
        }

Figured it out 弄清楚了

   using Excel = Microsoft.Office.Interop.Excel; //Excel Reference 

   public virtual Object ActiveSheet { get; set; } //Gets ActiveSheet from Excel (MUST HAVE!!!)


     private void button15_Click(object sender, EventArgs e)
        {
        //Allows Access to Solidworks (without SDK add-in)
        SldWorks swApp;
        swApp = null;
        swApp = (SldWorks)Activator.CreateInstance(Type.GetTypeFromProgID("SldWorks.Application"));

        ModelDoc2 swDoc = null;
        bool boolstatus = false;
        swDoc = ((ModelDoc2)(swApp.ActiveDoc));
        boolstatus = swDoc.Extension.SelectByID2("Design Table", "DESIGNTABLE", 0, 0, 0, false, 0, null, 0);

        //Open Solidworks Design Table
        swDoc.InsertFamilyTableEdit();

        //Gets ActiveSheet to Modify
        Excel.Application oXL;
        Excel.Workbook oWB;
        Excel.Worksheet oSheet;

        //Start Excel and get Application object.
        oXL = (Excel.Application)Marshal.GetActiveObject("Excel.Application"); 
        oXL.Visible = true;
        oWB = (Excel.Workbook)oXL.ActiveWorkbook; 
        oSheet = (Excel.Worksheet)oWB.ActiveSheet;
        //Generate Linear Guide Support in Solidworks    
        if (comboBox1.Text == "0")//No External Rails    
        {    
         sheet.Cells[6, 4] = "0"; //Cell Location [y-axis, x-axis]    
        }    

        //Close Design Table
        swDoc.CloseFamilyTable();

        //Quit Excel
        oXL.Quit();
        }

声明:本站的技术帖子网页,遵循CC BY-SA 4.0协议,如果您需要转载,请注明本站网址或者原文地址。任何问题请咨询:yoyou2525@163.com.

 
粤ICP备18138465号  © 2020-2024 STACKOOM.COM